package org.dromara.system.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.system.domain.AiMcpDo;
import org.dromara.system.domain.bo.AiMcpBo;
import org.dromara.system.domain.vo.AiMcpVo;
import org.dromara.system.mapper.AiMcpMapper;
import org.dromara.system.service.IAiMcpService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 模型上下文协议Service业务层处理
 *
 * @author Lion Li
 * @date 2025-09-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class AiMcpServiceImpl implements IAiMcpService {

    private final AiMcpMapper baseMapper;

    /**
     * 查询模型上下文协议
     *
     * @param id 主键
     * @return 模型上下文协议
     */
    @Override
    public AiMcpVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询模型上下文协议列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 模型上下文协议分页列表
     */
    @Override
    public TableDataInfo<AiMcpVo> queryPageList(AiMcpBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<AiMcpDo> lqw = buildQueryWrapper(bo);
        Page<AiMcpVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的模型上下文协议列表
     *
     * @param bo 查询条件
     * @return 模型上下文协议列表
     */
    @Override
    public List<AiMcpVo> queryList(AiMcpBo bo) {
        LambdaQueryWrapper<AiMcpDo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<AiMcpDo> buildQueryWrapper(AiMcpBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<AiMcpDo> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(AiMcpDo::getId);
        lqw.like(StringUtils.isNotBlank(bo.getName()), AiMcpDo::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getIntroduce()), AiMcpDo::getIntroduce, bo.getIntroduce());
        lqw.eq(StringUtils.isNotBlank(bo.getInputData()), AiMcpDo::getInputData, bo.getInputData());
        lqw.eq(StringUtils.isNotBlank(bo.getOutputData()), AiMcpDo::getOutputData, bo.getOutputData());
        lqw.eq(StringUtils.isNotBlank(bo.getUrl()), AiMcpDo::getUrl, bo.getUrl());
        lqw.eq(bo.getSort() != null, AiMcpDo::getSort, bo.getSort());
        lqw.eq(bo.getAgentId() != null, AiMcpDo::getAgentId, bo.getAgentId());
        lqw.eq(bo.getStatus() != null, AiMcpDo::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增模型上下文协议
     *
     * @param bo 模型上下文协议
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(AiMcpBo bo) {
        AiMcpDo add = MapstructUtils.convert(bo, AiMcpDo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改模型上下文协议
     *
     * @param bo 模型上下文协议
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(AiMcpBo bo) {
        AiMcpDo update = MapstructUtils.convert(bo, AiMcpDo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(AiMcpDo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除模型上下文协议信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
